compute_fishers_enrichment <- function(ions_id_sig_list) {

if (is.list(ions_id_sig_list) == FALSE) {
	print("please supply a list")
}

#loop over significant ions
enriched_cat_01 <- list()
enriched_cat_05 <- list()
enriched_cat_all <- list()
for (j in 1:length(ions_id_sig_list)) { 
	ion_id_sig <- ions_id_sig_list[[j]]
	if (length(ion_id_sig) >= 2) {
	selrows <- list()
	for (i in 1:length(ion_id_sig)) {
  		rows <- which(annotation$ionIdx == ion_id_sig[i])
  		selrows[[i]] <- rows[1]
	}
	ion_id_sig_ann <- unlist(selrows)
	counts_classes <- as.data.frame(table(annotation$detailed_compound_class[ion_id_sig_ann]))
	names(counts_classes) <- c("group_name", "counts")
	counts_classes <- counts_classes[-1,] #remove the "-" no category one

	for (i in 1:nrow(ions)) {
  		rows <- which(annotation$ionIdx == ions$ionIdx[i])
  		selrows[[i]] <- rows[1]
	}
	ion_id_all_ann <- unlist(selrows)
	counts_classes_all <- as.data.frame(table(annotation$detailed_compound_class[ion_id_all_ann]))
	names(counts_classes_all) <- c("group_name", "counts")
	counts_classes_all <- counts_classes_all[-1,] #remove the "-" no category one
	
	counts_classes$number_of_compounds = "0"
	for (i in 1:nrow(counts_classes)) {
	  	index <- which(as.character(counts_classes_all$group_name) == 
	  	as.character(counts_classes$group_name[i]))
	  	if (length(index) >= 1) {  		
	  		counts_classes$number_of_compounds[i] <- counts_classes_all$counts[index] 
  		}
	}

	counts_classes$Fishers_enrichment_pval = "-"
#	counts_classes$conf_interv_low = "-"
#	counts_classes$conf_interv_high = "-"
	for (i in 1:nrow(counts_classes)) {
		cat_part_of_group <- as.numeric(counts_classes$counts[i])
		cat_not_part_of_group <- as.numeric(counts_classes$number_of_compounds[i]) -
		cat_part_of_group
		rest_in_group <- as.numeric(length(ion_id_sig)) - cat_part_of_group
		rest_not_in_group <- length(ion_id_all_ann) - as.numeric(length(ion_id_sig))
 		mat_for_enrichment <- matrix(c(cat_part_of_group, cat_not_part_of_group, rest_in_group, rest_not_in_group), nrow=2, ncol=2)
 		fisher_test_res <- fisher.test(mat_for_enrichment, alternative="greater", 
 		conf.int = TRUE)
  		counts_classes$Fishers_enrichment_pval[i] <- fisher_test_res[1]
  		#counts_classes$conf_interv_low[i] <- fisher_test_res$conf.int[1]
  		#counts_classes$conf_interv_high[i] <- fisher_test_res$conf.int[2]  		
	}
	names(counts_classes)[c(2,3)] <- c("n_in_ion_list", "n_in_annotation")
	enriched_cat_01[[j]] <- counts_classes[counts_classes$Fishers_enrichment_pval <= 0.01 & counts_classes$n_in_ion_list > 1,] 
	enriched_cat_05[[j]] <- counts_classes[counts_classes$Fishers_enrichment_pval <= 0.05 & counts_classes$n_in_ion_list > 1,]
	enriched_cat_all[[j]]  <- counts_classes[counts_classes$n_in_ion_list > 1,]
}
}
names(enriched_cat_01) <- names(ions_id_sig_list)
names(enriched_cat_05) <- names(ions_id_sig_list)
names(enriched_cat_all) <- names(ions_id_sig_list)

return(list(enriched_cat_01=enriched_cat_01, enriched_cat_05=enriched_cat_05, enriched_cat_all=enriched_cat_all))

#can use 05, enrichments based on one ion are removed
}